package net.blumia.pcmdroid

import android.app.Application
import net.blumia.pcmdroid.databases.PcmRoomDatabase
import net.blumia.pcmdroid.repository.ServerRepository

class MainApplication : Application() {
    // Using by lazy so the database and the repository are only created when they're needed
    // rather than when the application starts
    val database by lazy { PcmRoomDatabase.getDatabase(this) }
    val repository by lazy { ServerRepository(database.serverDao()) }
}